﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WPFGridsBenchmark
{
    /// <summary>
    /// Interaction logic for XceedDataGrid.xaml
    /// </summary>
    public partial class XceedDataGrid : TestGrid
    {
        public XceedDataGrid(bool fixedColumnWidth)
        {
            InitializeComponent();
            // default colum size is fixed
            // autowidth is only possible by method calls https://xceed.com/forums/topic/How-to-Set-Column-width-to-the-size-of-the-content/
        }

        public override void Dispose()
        {
            _grid.ItemsSource = null;
            base.Dispose();
        }

        public override void Load(IList data)
        {
            if (data == null)
            {
                _grid.ItemsSource = null;
            }
            else
            {
                _grid.ItemsSource = new ListCollectionView(data);
            }
        }

        public override void Sort(bool ascending)
        {
            ICollectionView dataView = CollectionViewSource.GetDefaultView(_grid.ItemsSource);
            dataView.SortDescriptions.Clear();
            dataView.SortDescriptions.Add(new SortDescription("ID", ascending ? ListSortDirection.Ascending : ListSortDirection.Descending));
        }
        public override void ScrollInView(int rowNumber)
        {
            object item = ((ListCollectionView)_grid.ItemsSource).GetItemAt(rowNumber);
            _grid.BringItemIntoView(item);
        }

        public override string GetGridInfo()
        {
            System.Reflection.AssemblyName asName = _grid.GetType().Assembly.GetName();
            return asName.Name + "." + asName.Version;
        }
    }
}
